微信公众号搜"智元新知"关注
微信扫一扫可直接关注哦!

Unix/Linux 脚本中 “set -e” 的作用

-----------------------------------------------------------
#!/bin/bash

set -e

command 1
command 2
...

exit 0
----------------------------------------------------------

Every script you write should include set -e at the top. This tells bash that it should exit the script if any statement returns a non-true return value. The benefit of using -e is that it prevents errors snowballing into serIoUs issues when they Could have been caught earlier. Again,for readability you may want to use set -o errexit.

你写的每个脚本都应该在文件开头加上set -e,这句语句告诉bash如果任何语句的执行结果不是true则应该退出。这样的好处是防止错误像滚雪球般变大导致一个致命的错误,而这些错误本应该在之前就被处理掉。如果要增加可读性,可以使用set -o errexit,它的作用与set -e相同。


Using -e gives you error checking for free. If you forget to check something,bash will do it for you. Unfortunately it means you can't check $? as bash will never get to the checking code if it isn't zero. There are other constructs you Could use:

使用-e帮助你检查错误。如果你忘记检查(执行语句的结果),bash会帮你执行。不幸的是,你将无法检查$?,因为如果执行的语句不是返回0,bash将无法执行到检查的代码。你可以使用其他的结构:

[plain] view plain copy
  1. command
  2. if["$?"-ne0];then
  3. echo"commandFailed";
  4. exit1;
  5. fi

Could be replaced with

能够被代替为

copy

    command||{echo"commandFailed";exit1;}
or

或者

copy

    if!command;then
  1. echo"commandFailed";
  2. exit1;
  3. fi

What if you have a command that returns non-zero or you are not interested in its return value? You can use command || true,or if you have a longer section of code,you can turn off the error checking,but I recommend you use this sparingly.

如果你有一个命令返回非0或者你对语句执行的结果不关心,那你可以使用command || true,或者你有一段很长的代码,你可以关闭错误检查(不使用set -e),但是我还是建议你保守地使用这个语句。

原文地址:https://www.jb51.cc/bash/391163.html

版权声明:本文内容由互联网用户自发贡献,该文观点与技术仅代表作者本人。本站仅提供信息存储空间服务,不拥有所有权,不承担相关法律责任。如发现本站有涉嫌侵权/违法违规的内容, 请发送邮件至 dio@foxmail.com 举报,一经查实,本站将立刻删除。

相关推荐